#define STRICT 1
#define ORBITER_MODULE

#include "Orbitersdk.h"
#include "DlgCtrl.h"
#include "resource.h"

class AttachmentPointRevealer : public oapi::Module
{
public:
	AttachmentPointRevealer(HINSTANCE hDLL) : Module(hDLL) {};
	~AttachmentPointRevealer() {};
};

static struct {
	HINSTANCE hDLL;
	AttachmentPointRevealer *revealer;
	HWND hDlg;

	DWORD cmd;
} g_Param;

void OpenDlgClbk (void *context);
BOOL CALLBACK DlgProc (HWND, UINT, WPARAM, LPARAM);

DLLCLBK void InitModule(HINSTANCE hDLL)
{
	g_Param.hDLL = hDLL;
	g_Param.cmd = oapiRegisterCustomCmd("Attachment Point Revealer", "Show all attachment points.", OpenDlgClbk, NULL);
	oapiRegisterCustomControls(hDLL);
	g_Param.revealer = new AttachmentPointRevealer(hDLL);
	oapiRegisterModule(g_Param.revealer);
}

DLLCLBK void ExitModule(HINSTANCE hDLL)
{
	oapiUnregisterCustomCmd(g_Param.cmd);
	oapiUnregisterCustomControls(hDLL);
	
	delete g_Param.revealer;
	g_Param.revealer = NULL;
}

void OpenDlgClbk (void *context)
{
	HWND hDlg = oapiOpenDialog(g_Param.hDLL, IDD_DIALOG, DlgProc);
	if(hDlg) g_Param.hDlg = hDlg;
}

BOOL CALLBACK DlgProc (HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	int result;
	switch(uMsg) {
	case WM_DESTROY:
		g_Param.hDlg = NULL;
		return 0;
	case WM_COMMAND:
		switch(LOWORD(wParam)) {
		case IDCANCEL:
			oapiCloseDialog (hWnd);
			return TRUE;
		case IDC_CHECKBOX:
			result = SendDlgItemMessage(hWnd, IDC_CHECKBOX, BM_GETCHECK, 0, 0);
			if(result == BST_CHECKED) oapiSetShowGrapplePoints(true);
			else oapiSetShowGrapplePoints(false);
			return TRUE;
		}
	}
	return oapiDefDialogProc(hWnd, uMsg, wParam, lParam);
}
